//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <mmsystem.hpp>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <math.h>

#include "Centi.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TArea *Area;
//---------------------------------------------------------------------------
__fastcall TArea::TArea(TComponent* Owner)
    : TForm(Owner)
{
    ShowCursor(false);
}
//---------------------------------------------------------------------------
void __fastcall TArea::CheckKeyPress(TObject *Sender, char &Key)
{
    if (Key == 27)
        EscOn = true;
    if (Key == 'p')
        PauseOn = true;
}
//---------------------------------------------------------------------------
void __fastcall TArea::GameStart(TObject *Sender)
{
    char ch[10];
    randomize();
    //Open high score file
    if ((hsfile = fopen("highscor.cen", "r")) == NULL){
		hsfile = fopen("highscor.cen", "w+");
		fputs("0", hsfile);
		hsc = 0;
	}
	else{
		for(x=0; ((ch[x] = getc(hsfile)) != EOF) && (x < 10); ++x){}
        hsc = atol(ch);
	}
	fclose(hsfile);
    //Load user bitmaps
    LoadAllBitmaps();
    //Load user sounds
    ShotSd = false;
    CenSd = false;
    SpidSd = false;
    FleaSd = false;
    ScoSd = false;
    MushSd = false;
    LoadAllSounds();
    EscOn = false;
    PauseOn = false;
    FireOn = false;
    //Set all variables
    px = 312;
    py = 540;
    pgx = 15;
    pgy = 31;
    bx = -1;
    by = -1;
    bgx = -1;
    bgy = -1;
    decmax = 5.9;
    incmax = 5;
    inctop = 5;
    inc = -1;
    len = 8;
    lev = 1;
    liv = 3;
    dsr = 200;
    sr = 200;
    dfr = 200;
    fr = 200;
    drr = 600;
    rr = 600;
    dsmax = 1;
    smax = dsmax;
    dfmax = 0.5;
    fmax = dfmax;
    drmax = 0.25;
    rmax = drmax;
    sco = 0;
    nex = 12000;
    w = false;

    //Set centipede segments
    for(x=0; x<40; ++x){
        ocx[x] = -1;
        ocy[x] = -1;
        cx[x] = -1;
        cy[x] = -1;
        dir[x] = 1;
        vdir[x] = 1;
        vert[x] = 0;
        bloc[x] = 0;
        head[x] = 0;
        ccx[x] = -16;
        ccy[x] = -16;
    }
    y = rand()%30;
    for(x=0; x<len; ++x){
        ocx[x] = y;
        cx[x] = y;
    }
    cy[0] = 0;
    head[0] = 1;
    //Set spiders, fleas, and scorpions
    for(x=0; x<10; ++x){
        osx[x] = -1;
        osy[x] = -1;
        sx[x] = -1;
        sy[x] = -1;
        fx[x] = -1;
        fy[x] = -1;
        rx[x] = -1;
        ry[x] = -1;
    }
    //Maximize area
    WindowState = wsMaximized;
    GameArea = new TCanvas;
    Pxy = new TPoint;
    //Sets game area
    gameRect.Left = 79;
    gameRect.Top = 43;
    gameRect.Right = 561;
    gameRect.Bottom = 557;
    //Create canvas and game area handle
    HDC backdc = CreateCompatibleDC(Canvas->Handle);
    HBITMAP bkbmp = CreateCompatibleBitmap(Canvas->Handle, 800, 600);
    SelectObject(backdc, bkbmp);
    SelectPalette(backdc, ImgPlayer->Picture->Bitmap->Palette, false);
    Canvas->Handle = backdc;
    GameArea->Handle = backdc;
    GameArea->Brush->Color = clBlack;
    GameArea->FillRect(gameRect);
    GameArea->Brush->Color = clWhite;
    GameArea->FrameRect(gameRect);
    GameArea->Brush->Color = clBlack;
    //Clear grid
    for(x=0; x<30; ++x){
        for(y=0; y<32; ++y)
            grid[x][y] = 0;
    }
    //Set mushroom positions
    for(x=0; x<30; ++x){
        for(y=0; y<25; ++y){
            if (rand()%16 == 0){
                grid[x][y] = 4;
                GameArea->Draw((x * 16) + 80, (y * 16) + 44, ImgMush1->Picture->Bitmap);
            }
        }
    }
    grid[15][0] = 0;
    EraseGrid(15, 0);
    SetCursorPos(px, py);
}
//---------------------------------------------------------------------------

void __fastcall TArea::FireStart(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    FireOn = true;
}
//---------------------------------------------------------------------------

void __fastcall TArea::FireStop(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    FireOn = false;
}
//---------------------------------------------------------------------------

void __fastcall TArea::ScreenFrame(TObject *Sender)
{
    //Erase Mode
    RealizePalette(GameArea->Handle);
    eraseRect.Left = px;
    eraseRect.Top = py;
    eraseRect.Right = px + 16;
    eraseRect.Bottom = py + 16;
    GameArea->FillRect(eraseRect);
    //Erases shot image
    if ((bx != -1) && (by != -1)){
        eraseRect.Left = bx;
        eraseRect.Top = by;
        eraseRect.Right = bx + 16;
        eraseRect.Bottom = by + 16;
        GameArea->FillRect(eraseRect);
        for(x=-1; x<=1; ++x){
            DrawMushroom(bgx+x, bgy);
            DrawMushroom(bgx+x, bgy+1);
        }
    }
    //Erases centipede image
    for(x=39; x>=0; --x){
        if ((cx[x] >= 0) && (cy[x] >= 0)){
            eraseRect.Left = ccx[x];
            eraseRect.Top = ccy[x];
            eraseRect.Right = ccx[x] + 16;
            eraseRect.Bottom = ccy[x] + 16;
            GameArea->FillRect(eraseRect);
            DrawMushroom(cx[x], cy[x]);
        }
        if ((ocx[x] >= 0) && (ocy[x] >= 0))
            DrawMushroom(ocx[x], ocy[x]);
    }
    //Erases spider images
    for(x=0; x<smax; ++x){
        if ((sx[x] >= 0) || (sy[x] >= 0)){
            eraseRect.Left = csx[x];
            eraseRect.Top = csy[x];
            eraseRect.Right = csx[x] + 16;
            eraseRect.Bottom = csy[x] + 16;
            GameArea->FillRect(eraseRect);
            DrawMushroom(sx[x], sy[x]);
            DrawMushroom(osx[x], osy[x]);
            if ((sx[x] != osx[x]) && (sy[x] != osy[x])){
                DrawMushroom(sx[x], osy[x]);
                DrawMushroom(osx[x], sy[x]);
            }
        }
    }
    //Erases flea images
    for(x=0; x<fmax; ++x){
        if ((fx[x] >= 0) || (fy[x] >= 0)){
            eraseRect.Left = cfx[x];
            eraseRect.Top = cfy[x];
            eraseRect.Right = cfx[x] + 16;
            eraseRect.Bottom = cfy[x] + 16;
            GameArea->FillRect(eraseRect);
            DrawMushroom(fx[x], fy[x]);
            DrawMushroom(fx[x], fy[x]-1);
            DrawMushroom(fx[x], fy[x]-2);
        }
    }
    //Erases scorpion images
    for(x=0; x<rmax; ++x){
        if ((rx[x] >= 0) || (ry[x] >= 0)){
            eraseRect.Left = crx[x];
            eraseRect.Top = cry[x];
            eraseRect.Right = crx[x] + 16;
            eraseRect.Bottom = cry[x] + 16;
            GameArea->FillRect(eraseRect);
            DrawMushroom(rx[x], ry[x]);
            DrawMushroom(rx[x]-rdir[x], ry[x]);
            DrawMushroom(rx[x]-(rdir[x]*2), ry[x]);
        }
    }

    //Move Mode
    GetCursorPos(Pxy);
    opx = px;
    opy = py;
    px = Pxy->x;
    py = Pxy->y;
    //Sets player limit
    if (px < 80)
        px = 80;
    if (px > 544)
        px = 544;
    if (py < 444)
        py = 444;
    if (py > 540)
        py = 540;
    //Regulates speed
    cxy = sqrt(pow(px-opx, 2) + pow(py-opy, 2));
    if (cxy > 16){
        if (px > opx)
            px = opx + ceil(16 * ((float)abs(px-opx) / cxy));
        if (px < opx)
            px = opx - ceil(16 * ((float)abs(px-opx) / cxy));
        if (py > opy)
            py = opy + ceil(16 * ((float)abs(py-opy) / cxy));
        if (py < opy)
            py = opy - ceil(16 * ((float)abs(py-opy) / cxy));
    }
    pgx = (px - 72) / 16;
    pgy = (py - 36) / 16;
    if (ColiDet(px, py)){
        x = opx;
        if (px > opx){
            while(x<px){
                if (ColiDet(x+1, opy))
                    break;
                ++x;
            }
        }
        else if (px < opx){
            while(x>px){
                if (ColiDet(x-1, opy))
                    break;
                --x;
            }
        }
        opx = x;
        y = opy;
        if (py > opy){
            while(y<py){
                if (ColiDet(opx, y+1))
                    break;
                ++y;
            }
        }
        else if (py < opy){
            while(y>py){
                if (ColiDet(opx, y-1))
                    break;
                --y;
            }
        }
        opy = y;
        px = opx;
        py = opy;
    }
    SetCursorPos(px, py);
    if (FireOn && (bx == -1) && (by == -1)){
        bx = px;
        by = py;
        bgx = (px - 72) / 16;
        bgy = (py - 42) / 16;
        if (ShotSd)
            sndPlaySound("Shotfire.wav", SND_ASYNC | SND_FILENAME | SND_NOSTOP);
    }
    //Monster step code
    ++inc;
    if (inc == inctop){
        inc = 0;
        inctop = incmax;
        if (w)
            CentiSpawn();
        //Centipede step code
        w = false;
        for (x=39; x>=0; --x){
            ocx[x] = cx[x];
            ocy[x] = cy[x];
            if (cx[x] >= 0){
                //Segment is entering the level
                if ((cy[x] < 0) && (head[x] == 1)){
                    vert[x] = 1;
                    ++cy[x];
                    bloc[x] = 0;
                }
                //Segment is a head (leader)
                else if (head[x] == 1){
                    //Centipede not poisoned
                    if (vert[x] != 2){
                        //Sets new segment position if edge of screen
                        if (((dir[x] == -1) && (cx[x] == 0)) ||
                         ((dir[x] == 1) && (cx[x] == 29))){
                            vert[x] = 1;
                            if ((cy[x] == 0) && (vdir[x] == -1))
                                vdir[x] = 1;
                            if ((cy[x] == 31) && (vdir[x] == 1))
                               	vdir[x] = -1;
                            if ((grid[cx[x]][cy[x]+vdir[x]] == 0) || (bloc[x] == 3)){
                                cy[x] += vdir[x];
                                bloc[x] = 0;
                                if (vdir[x] == -1)
                                    w = true;
                            }
                            else
                              	++bloc[x];
                            dir[x] *= -1;
                        }
                        //Sets new segment position if obstacle hit
                        else if (grid[cx[x]+dir[x]][cy[x]] > 0){
                            vert[x] = 1;
                            //Check for poison
                            if (grid[cx[x]+dir[x]][cy[x]] >= 6)
                                vert[x] = 2;
                            if ((cy[x] == 0) && (vdir[x] == -1))
                                vdir[x] = 1;
                            if ((cy[x] == 31) && (vdir[x] == 1))
                               	vdir[x] = -1;
                            if ((grid[cx[x]][cy[x]+vdir[x]] == 0) || (bloc[x] == 3)){
                                cy[x] += vdir[x];
                                bloc[x] = 0;
                                if (vdir[x] == -1)
                                    w = true;
                            }
                            else{
                              	++bloc[x];
                                //Check for poison
                                if (grid[cx[x]][cy[x]+vdir[x]] >= 6)
                                    vert[x] = 2;
                            }
                            dir[x] *= -1;
                        }
                        // Sets new head position if no obstacles
                        else{
                            vert[x] = 0;
                            cx[x] += dir[x];
                        }
                    }
                    //Centipede poisoned
                    else{
                        vdir[x] = 1;
                        ++cy[x];
                        if (cy[x] == 31)
                            vert[x] = 1;
                    }
                    EraseGrid(cx[x], cy[x]);
	      	    }
                //Segment is not a head (follower)
                else{
                    cx[x] = cx[x-1];
                    cy[x] = cy[x-1];
                    dir[x] = dir[x-1];
                    vdir[x] = vdir[x-1];
                    if (vert[x-1] > 0)
                        vert[x] = 1;
                    else
                        vert[x] = 0;
                }
            }
        }
        //Centipede grid values
        for (x=39; x>=0; --x){
            if ((ocx[x] >= 0) && (ocy[x] >= 0) && (grid[ocx[x]][ocy[x]] == 5))
                grid[ocx[x]][ocy[x]] = 0;
        }
        for (x=39; x>=0; --x){
            if ((cx[x] >= 0) && (cy[x] >= 0))
                grid[cx[x]][cy[x]] = 5;
        }
        //Set spiders randomly
        if (rand()%sr == 0){
            for(x=0; x<smax; ++x){
                if ((sx[x] == -1) && (sy[x] == -1)){
                    if (px < 312){
                        sx[x] = 29;
                        osx[x] = 30;
                        sdir[x] = -1;
                    }
                    else{
                        sx[x] = 0;
                        sdir[x] = 1;
                    }
                    sy[x] = 23 + rand()%9;
                    svdir[x] = (rand()%2 * 2) - 1;
                    osy[x] = sy[x] - svdir[x];
                    break;
                }
            }
        }
        //Spider step code
        for(x=0; x<smax; ++x){
            if ((sx[x] >= 0) || (sy[x] >= 0)){
                osx[x] = sx[x];
                osy[x] = sy[x];
				if (((sy[x] == 23) && (svdir[x] == -1)) || ((sy[x] == 31) && (svdir[x] == 1)))
					svdir[x] *= -1;
				if (((sx[x] == -1) && (sdir[x] == -1)) || ((sx[x] == 30) && (sdir[x] == 1))){
                    osx[x] = -1;
                    osy[x] = -1;
					sx[x] = -1;
                    sy[x] = -1;
                }
                else{
                    grid[sx[x]][sy[x]] = 0;
                    EraseGrid(sx[x], sy[x]);
                    if (rand()%2 == 1)
                        sx[x] += sdir[x];
                    sy[x] += svdir[x];
                }
			}
        }
        //Set fleas randomly
        if (rand()%fr == 0){
            for(x=0; x<fmax; ++x){
                if ((fx[x] == -1) && (fy[x] == -1)){
                    fx[x] = rand()%30;
                    fs[x] = 1;
                    fy[x] = 0;
                    break;
                }
            }
        }
        //Flea step code
        for(x=0; x<fmax; ++x){
            if ((fx[x] >= 0) || (fy[x] >= 0)){
				if (fy[x] >= 32){
					fx[x] = -1;
                    fy[x] = -1;
                }
                else{
                    if (fs[x] == 1){
                        if ((grid[fx[x]][fy[x]] == 0) && (rand()%5 == 0))
                            grid[fx[x]][fy[x]] = 4;
                    }
                    else{
                        if ((grid[fx[x]][fy[x]] == 0) && (rand()%3 == 0))
                            grid[fx[x]][fy[x]] = 4;
                        if ((grid[fx[x]][fy[x]-1] == 0) && (rand()%3 == 0))
                            grid[fx[x]][fy[x]-1] = 4;
                    }
                    DrawMushroom(fx[x], fy[x]-1);
                    DrawMushroom(fx[x], fy[x]);
                    fy[x] += fs[x];
                }
			}
        }
        //Set scorpions randomly
        if (rand()%rr == 0){
            for(x=0; x<rmax; ++x){
                if ((rx[x] == -1) && (ry[x] == -1)){
                    if (rand()%2 == 0){
                        rx[x] = 1;
                        rdir[x] = 1;
                    }
                    else{
                        rx[x] = 28;
                        rdir[x] = -1;
                    }
                    ry[x] = rand()%20;
                    break;
                }
            }
        }
        //Scorpion step code
        for(x=0; x<rmax; ++x){
            if ((rx[x] >= 0) || (ry[x] >= 0)){
				if ((rx[x] >= 30) || (rx[x] <= -1)){
					rx[x] = -1;
                    ry[x] = -1;
                }
                else{
                    if ((grid[rx[x]][ry[x]] >= 1) && (grid[rx[x]][ry[x]] <= 4))
                        grid[rx[x]][ry[x]] += 5;
                    if ((grid[rx[x]-rdir[x]][ry[x]] >= 1) && (grid[rx[x]-rdir[x]][ry[x]] <= 4))
                        grid[rx[x]-rdir[x]][ry[x]] += 5;
                    EraseGrid(rx[x], ry[x]);
                    DrawMushroom(rx[x], ry[x]);
                    EraseGrid(rx[x]-rdir[x], ry[x]);
                    DrawMushroom(rx[x]-rdir[x], ry[x]);
                    EraseGrid(rx[x]-(rdir[x]*2), ry[x]);
                    DrawMushroom(rx[x]-(rdir[x]*2), ry[x]);
                    rx[x] += (rdir[x]*2);
                }
			}
        }
    }
    //Find monster grid places
    for (x=39; x>=0; --x){
        ccx[x] = MidPoint(ocx[x], cx[x], 80);
        ccy[x] = MidPoint(ocy[x], cy[x], 44);
    }
    for (x=0; x<smax; ++x){
        csx[x] = MidPoint(osx[x], sx[x], 80);
        csy[x] = MidPoint(osy[x], sy[x], 44);
    }
    for (x=0; x<fmax; ++x){
        cfx[x] = (fx[x] * 16) + 80;
        cfy[x] = MidPoint(fy[x]-fs[x], fy[x], 44);
    }
    for (x=0; x<rmax; ++x){
        crx[x] = MidPoint(rx[x]-(rdir[x]*2), rx[x], 80);
        cry[x] = (ry[x] * 16) + 44;
    }
    //Shot check code
    for(z=0; z<2; ++z){
        if ((bx != -1) && (by != -1)){
            by -= 16;
            --bgy;
            if (bgy >= 0){
                //Shot hits centipede
                y = -1;
                dist = -1;
                for(x=39; x>=0; --x){
                    if ((abs(ccx[x] - bx) < 16) && (abs(ccy[x] - by) < 16)){
                        if ((abs(ccx[x] - bx) + abs(ccy[x] - by)) > dist){
                            dist = abs(ccx[x] - bx) + abs(ccy[x] - by);
                            y = x;
                        }
                    }
                }
                if (y >= 0){
                    if (y < 39)
                        head[y+1] = 1;
                    grid[cx[y]][cy[y]] = 4;
                    DrawMushroom(cx[y], cy[y]);
                    DrawMushroom(ocx[y], ocy[y]);
                    if (head[y] == 1)
                        sco += 100;
                    else
                        sco += 10;
                    cx[y] = -1;
                    cy[y] = -1;
                    bx = -1;
                    by = -1;
                    bgx = -1;
                    bgy = -1;
                    if (CenSd)
                        sndPlaySound("Centihit.wav", SND_ASYNC | SND_FILENAME);
                }
                //Shot hits spider
                y = -1;
                dist = -1;
                for(x=0; x<smax; ++x){
                    if ((abs(csx[x] - bx) < 16) && (abs(csy[x] - by) < 16)){
                        if ((abs(csx[x] - bx) + abs(csy[x] - by)) > dist){
                            dist = abs(csx[x] - bx) + abs(csy[x] - by);
                            y = x;
                        }
                    }
                }
                if (y >= 0){
                    if ((sx[y] > -1) && (sx[y] < 30))
                        grid[sx[y]][sy[y]] = 4;
                    DrawMushroom(sx[y], sy[y]);
                    DrawMushroom(osx[y], osy[y]);
                    if (sy[y] >= 29)
                        sco += 900;
                    else if (sy[y] >= 26)
                        sco += 600;
                    else if (sy[y] >= 23)
                        sco += 300;
                    osx[y] = -1;
                    osy[y] = -1;
                    sx[y] = -1;
                    sy[y] = -1;
                    bx = -1;
                    by = -1;
                    bgx = -1;
                    bgy = -1;
                    if (SpidSd)
                        sndPlaySound("Spidhit.wav", SND_ASYNC | SND_FILENAME);
                }
                //Shot hits flea
                y = -1;
                dist = -1;
                for(x=0; x<fmax; ++x){
                    if ((abs(cfx[x] - bx) < 16) && (abs(cfy[x] - by) < 16)){
                        if ((abs(cfx[x] - bx) + abs(cfy[x] - by)) > dist){
                            dist = abs(cfx[x] - bx) + abs(cfy[x] - by);
                            y = x;
                        }
                    }
                }
                if (y >= 0){
                    if (fs[y] == 1){
                        ++fs[y];
                        DrawMushroom(fx[y], fy[y]);
                        DrawMushroom(fx[y], fy[y]-1);
                    }
                    else{
                        grid[fx[y]][fy[y]] = 4;
                        DrawMushroom(fx[y], fy[y]);
                        DrawMushroom(fx[y], fy[y]-1);
                        DrawMushroom(fx[y], fy[y]-2);
                        fx[y] = -1;
                        fy[y] = -1;
                    }
                    sco += 100;
                    bx = -1;
                    by = -1;
                    bgx = -1;
                    bgy = -1;
                    if (FleaSd)
                        sndPlaySound("Fleahit.wav", SND_ASYNC | SND_FILENAME);
                }
                //Shot hits scorpion
                y = -1;
                dist = -1;
                for(x=0; x<rmax; ++x){
                    if ((abs(crx[x] - bx) < 16) && (abs(cry[x] - by) < 16)){
                        if ((abs(crx[x] - bx) + abs(cry[x] - by)) > dist){
                            dist = abs(crx[x] - bx) + abs(cry[x] - by);
                            y = x;
                        }
                    }
                }
                if (y >= 0){
                    if ((rx[y] > -1) && (rx[y] < 30))
                        grid[rx[y]][ry[y]] = 4;
                    DrawMushroom(rx[y], ry[y]);
                    DrawMushroom(rx[y]-rdir[y], ry[y]);
                    DrawMushroom(rx[y]-(rdir[y]*2), ry[y]);
                    rx[y] = -1;
                    ry[y] = -1;
                    sco += 1000;
                    bx = -1;
                    by = -1;
                    bgx = -1;
                    bgy = -1;
                    if (ScoSd)
                        sndPlaySound("Scorphit.wav", SND_ASYNC | SND_FILENAME);
                }
                //Shot hits mushroom
                if ((grid[bgx][bgy] >= 1) && (grid[bgx][bgy] <= 4)){
                    --grid[bgx][bgy];
                    EraseGrid(bgx, bgy);
                    DrawMushroom(bgx, bgy);
                    bx = -1;
                    by = -1;
                    bgx = -1;
                    bgy = -1;
                    ++sco;
                    if (MushSd)
                        sndPlaySound("Mushhit.wav", SND_ASYNC | SND_FILENAME);
                }
                //Shot hits poison mushroom
                if ((grid[bgx][bgy] >= 6) && (grid[bgx][bgy] <= 9)){
                    if (grid[bgx][bgy] >= 7)
                        --grid[bgx][bgy];
                    else
                        grid[bgx][bgy] = 0;
                    EraseGrid(bgx, bgy);
                    DrawMushroom(bgx, bgy);
                    bx = -1;
                    by = -1;
                    bgx = -1;
                    bgy = -1;
                    ++sco;
                    if (MushSd)
                        sndPlaySound("Mushhit.wav", SND_ASYNC | SND_FILENAME);
                }
            }
            if (by < 28){
                bx = -1;
                by = -1;
                bgx = -1;
                bgy = -1;
            }
        }
    }
    //Check score stuff
    if (sco >= nex){
        nex += 12000;
        if (liv < 9)
            ++liv;
    }
    if (sco > hsc)
        hsc = sco;

    //Draw Mode
    for(x=-2; x<3; ++x){
        for(y=-2; y<3; ++y)
            DrawMushroom(pgx+x, pgy+y);
    }
    GameArea->Draw(px, py, ImgPlayer->Picture->Bitmap);
    //Draws centipede
    for(x=39; x>=0; --x){
        if ((cx[x] >= 0) && (cy[x] >= 0)){
            if (head[x] == 1){
                if (vert[x] == 0){
                    if (dir[x] == 1)
                        GameArea->Draw(ccx[x], ccy[x], ImgHright->Picture->Bitmap);
                    else
                        GameArea->Draw(ccx[x], ccy[x], ImgHleft->Picture->Bitmap);
                }
                else{
                    if (vdir[x] == 1)
                        GameArea->Draw(ccx[x], ccy[x], ImgHdown->Picture->Bitmap);
                    else
                        GameArea->Draw(ccx[x], ccy[x], ImgHup->Picture->Bitmap);
                }
            }
            else
                GameArea->Draw(ccx[x], ccy[x], ImgSeg->Picture->Bitmap);
        }
    }
    //Draws spiders
    for(x=0; x<smax; ++x){
        if ((sx[x] >= 0) || (sy[x] >= 0))
            GameArea->Draw(csx[x], csy[x], ImgSpider->Picture->Bitmap);
    }
    //Draws fleas
    for(x=0; x<fmax; ++x){
        if ((fx[x] >= 0) || (fy[x] >= 0))
            GameArea->Draw(cfx[x], cfy[x], ImgFlea->Picture->Bitmap);
    }
    //Draws scorpions
    for(x=0; x<rmax; ++x){
        if ((rx[x] >= 0) || (ry[x] >= 0)){
            if (rdir[x] == 1)
                GameArea->Draw(crx[x], cry[x], ImgRscorp->Picture->Bitmap);
            else
                GameArea->Draw(crx[x], cry[x], ImgLscorp->Picture->Bitmap);
        }
    }
    if ((bx != -1) && (by != -1))
        GameArea->Draw(bx, by, ImgShot->Picture->Bitmap);
    GameArea->Brush->Color = clWhite;
    GameArea->FrameRect(gameRect);
    GameArea->Brush->Color = clBlack;
    RealizePalette(Canvas->Handle);
    Canvas->CopyRect(gameRect, GameArea, gameRect);
    ScoreBox->Caption = sco;
    HighBox->Caption = hsc;
    LevelBox->Caption = lev;
    LivesBox->Caption = (int)liv;

    //Condition Check Mode
    if (EscOn){
        GameTimer->Enabled = false;
        ShowCursor(true);
        SetCursorPos(400, 300);
        if (MessageBox(Handle, "Would you like to exit?", "Exit Centipede?", MB_YESNO) == IDYES)
            ExitGame();
        SetCursorPos(px, py);
        ShowCursor(false);
        GameTimer->Enabled = true;
        EscOn = false;
    }
    if (PauseOn){
        GameTimer->Enabled = false;
        ShowCursor(true);
        SetCursorPos(400, 300);
        MessageBox(Handle, "Press OK to resume", "Game Paused", MB_OK);
        SetCursorPos(px, py);
        ShowCursor(false);
        GameTimer->Enabled = true;
        PauseOn = false;
    }
    //Check for new level
    v = true;
    for(x=0; x<len; ++x){
        if ((cx[x] >= 0) || (cy[x] >= 0))
            v = false;
    }
    if (v)
        NewLevel();
    //Collision Detection
    v = false;
    for(x=39; x>=0; --x){
        if ((abs(ccx[x] - px) < 12) && (abs(ccy[x] - py) < 12))
            v = true;
    }
    for(x=0; x<smax; ++x){
        if ((abs(csx[x] - px) < 12) && (abs(csy[x] - py) < 12))
            v = true;
    }
    for(x=0; x<fmax; ++x){
        if ((abs(cfx[x] - px) < 12) && (abs(cfy[x] - py) < 12))
            v = true;
    }
    for(x=0; x<rmax; ++x){
        if ((abs(crx[x] - px) < 12) && (abs(cry[x] - py) < 12))
            v = true;
    }
    if (v)
        NewLife();
}
//---------------------------------------------------------------------------

