//---------------------------------------------------------------------------
#ifndef CentiH
#define CentiH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TArea : public TForm
{
__published:	// IDE-managed Components
    TPanel *ScoreBox;
    TLabel *ScoreLabel;
    TPanel *HighBox;
    TLabel *HighLabel;
    TPanel *LivesBox;
    TLabel *LivesLabel;
    TPanel *LevelBox;
    TLabel *LevelLabel;
    TImage *ImgPlayer;
    TImage *ImgShot;
    TImage *ImgSeg;
    TImage *ImgHleft;
    TImage *ImgHright;
    TImage *ImgHup;
    TImage *ImgHdown;
    TImage *ImgSpider;
    TImage *ImgFlea;
    TImage *ImgLscorp;
    TImage *ImgRscorp;
    TImage *ImgMush1;
    TImage *ImgMush2;
    TImage *ImgMush3;
    TImage *ImgMush4;
    TImage *ImgPois1;
    TImage *ImgPois2;
    TImage *ImgPois3;
    TImage *ImgPois4;
    TTimer *GameTimer;
    void __fastcall CheckKeyPress(TObject *Sender, char &Key);
    void __fastcall GameStart(TObject *Sender);
    void __fastcall FireStart(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FireStop(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall ScreenFrame(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TArea(TComponent* Owner);
    void __fastcall ScreenFrame(TObject*, bool&);
    TCanvas *GameArea;
    TRect eraseRect, gameRect;
    TPoint *Pxy;
    int x, y, z, px, py, opx, opy, bx, by, ccx[40], ccy[40], csx[10], csy[10],
        sr, smax, cfx[10], cfy[10], fr, fmax, crx[10], cry[10], rr, rmax,
        dist, lev;
    char grid[30][32], pgx, pgy, bgx, bgy, inc, inctop, incmax, cx[40], cy[40],
        ocx[40], ocy[40], dir[40], vdir[40], vert[40], bloc[40], head[40],
        sx[10], sy[10], osx[10], osy[10], sdir[10], svdir[10], fx[10], fy[10],
        fs[10], rx[10], ry[10], rdir[10], len, liv;
    long sco, nex, hsc;
    float decmax, dsr, dsmax, dfr, dfmax, drr, drmax, cxy;
    bool EscOn, PauseOn, FireOn, DrawAll, v, w, ShotSd, CenSd, SpidSd, FleaSd,
        ScoSd, MushSd;
    FILE *hsfile;

    //Game Functions ---------------------------------------------------------

    int MidPoint(char op, char np, char ofs){
        return ((op * 16) + ofs) + (((np * 16) + ofs) - ((op * 16) + ofs)) * ((double)inc / (double)inctop);
    }

    void EraseGrid(char xp, char yp){
        eraseRect.Left = (xp * 16) + 80;
        eraseRect.Top = (yp * 16) + 44;
        eraseRect.Right = eraseRect.Left + 16;
        eraseRect.Bottom = eraseRect.Top + 16;
        GameArea->FillRect(eraseRect);
    }

    void DrawMushroom(char xp, char yp){
        if ((xp < 0) || (xp > 29) || (yp < 0) || (yp > 31))
            return;
        if (grid[xp][yp] == 4)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgMush1->Picture->Bitmap);
        else if (grid[xp][yp] == 3)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgMush2->Picture->Bitmap);
        else if (grid[xp][yp] == 2)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgMush3->Picture->Bitmap);
        else if (grid[xp][yp] == 1)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgMush4->Picture->Bitmap);
        else if (grid[xp][yp] == 9)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgPois1->Picture->Bitmap);
        else if (grid[xp][yp] == 8)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgPois2->Picture->Bitmap);
        else if (grid[xp][yp] == 7)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgPois3->Picture->Bitmap);
        else if (grid[xp][yp] == 6)
            GameArea->Draw((xp * 16) + 80, (yp * 16) + 44, ImgPois4->Picture->Bitmap);
    }

    void NewLevel()
    {
        //Set variables for new level
        ++lev;
        if (decmax > 2.5)
            decmax *= 0.96;
        if (dsr > 1.5)
            dsr *= 0.875;
        if (dfr > 1.5)
            dfr *= 0.875;
        if (drr > 1.5)
            drr *= 0.875;
        if (dsmax < 10)
            dsmax += 0.5;
        if (dfmax < 10)
            dfmax += 0.5;
        if (drmax < 10)
            drmax += 0.25;
        incmax = decmax;
        sr = dsr;
        fr = dfr;
        rr = drr;
        smax = dsmax;
        fmax = dfmax;
        rmax = drmax;
        w = false;
        if (len < 40)
            ++len;
        //Set centipede segments
        for(x=0; x<40; ++x){
            ocx[x] = -1;
            ocy[x] = -1;
            cx[x] = -1;
            cy[x] = -1;
            dir[x] = 1;
            vdir[x] = 1;
            vert[x] = 0;
            bloc[x] = 0;
            head[x] = 0;
            ccx[x] = -16;
            ccy[x] = -16;
        }
        y = rand()%30;
        for(x=0; x<len; ++x){
            ocx[x] = y;
            cx[x] = y;
        }
        cy[0] = 0;
        head[0] = 1;
        grid[15][0] = 0;
        EraseGrid(15, 0);
    }

    bool ColiDet(int xp, int yp)
    {
        bool b=false;
        int xg, yg;
        xg = (xp - 79) / 16;
        yg = (yp - 43) / 16;
        if ((grid[xg][yg] >= 1) && (grid[xg][yg] <= 4))
            b = true;
        xg = (xp - 66) / 16;
        if ((grid[xg][yg] >= 1) && (grid[xg][yg] <= 4))
            b = true;
        yg = (yp - 30) / 16;
        if ((grid[xg][yg] >= 1) && (grid[xg][yg] <= 4))
            b = true;
        xg = (xp - 79) / 16;
        if ((grid[xg][yg] >= 1) && (grid[xg][yg] <= 4))
            b = true;
        return b;
    }

    void ExitGame()
    {
        char ch[10];
        ltoa(hsc, ch, 10);
        hsfile = fopen("highscor.cen", "w");
	    fputs(ch, hsfile);
	    fclose(hsfile);
        Application->Terminate();
    }

    void GameOver()
    {
        GameTimer->Enabled = false;
        ShowCursor(true);
        SetCursorPos(400, 300);
        if (MessageBox(Handle, "Try again?", "Game Over!", MB_YESNO) == IDNO)
            ExitGame();
        ShowCursor(false);
        GameTimer->Enabled = true;
        //Set only variables not set by NewLife
        EscOn = false;
        PauseOn = false;
        FireOn = false;
        decmax = 5.9;
        incmax = 5;
        inctop = 5;
        len = 8;
        lev = 1;
        liv = 3;
        dsr = 200;
        sr = 200;
        dfr = 200;
        fr = 200;
        drr = 600;
        rr = 600;
        dsmax = 1;
        smax = dsmax;
        dfmax = 0.5;
        fmax = dfmax;
        drmax = 0.25;
        rmax = drmax;
        sco = 0;
        nex = 12000;
    }

    void NewLife()
    {
        --liv;
        if (liv == 0)
            GameOver();
        px = 312;
        py = 540;
        pgx = 15;
        pgy = 31;
        bx = -1;
        by = -1;
        bgx = -1;
        bgy = -1;
        inc = -1;
        w = false;

        //Set centipede segments
        for(x=0; x<40; ++x){
            ocx[x] = -1;
            ocy[x] = -1;
            cx[x] = -1;
            cy[x] = -1;
            dir[x] = 1;
            vdir[x] = 1;
            vert[x] = 0;
            bloc[x] = 0;
            head[x] = 0;
        }
        y = rand()%30;
        for(x=0; x<len; ++x){
            ocx[x] = y;
            cx[x] = y;
        }
        cy[0] = 0;
        head[0] = 1;
        //Set spiders, fleas, and scorpions
        for(x=0; x<10; ++x){
            osx[x] = -1;
            osy[x] = -1;
            sx[x] = -1;
            sy[x] = -1;
            fx[x] = -1;
            fy[x] = -1;
            rx[x] = -1;
            ry[x] = -1;
        }
        GameArea->Brush->Color = clBlack;
        GameArea->FillRect(gameRect);
        GameArea->Brush->Color = clWhite;
        GameArea->FrameRect(gameRect);
        GameArea->Brush->Color = clBlack;
        //Clear grid
        for(x=0; x<30; ++x){
            for(y=0; y<32; ++y)
                grid[x][y] = 0;
        }
        //Set mushroom positions
        for(x=0; x<30; ++x){
            for(y=0; y<25; ++y){
                if (rand()%16 == 0){
                    grid[x][y] = 4;
                    GameArea->Draw((x * 16) + 80, (y * 16) + 44, ImgMush1->Picture->Bitmap);
                }
            }
        }
        grid[15][0] = 0;
        EraseGrid(15, 0);
        SetCursorPos(px, py);
    }

    void CentiSpawn()
    {
        int i;
        for(i=0; i<40; ++i){
            if ((cx[i] == -1) && (cy[i] == -1)){
                if (rand()%2 == 0){
                    ocx[i] = 30;
                    cx[i] = 29;
                    dir[i] = -1;
                }
                else{
                    ocx[i] = -1;
                    cx[i] = 0;
                    dir[i] = 1;
                }
                ocy[i] = 19 + rand()%6;
                cy[i] = ocy[i];
                vdir[i] = 1;
                vert[i] = 0;
                bloc[i] = 0;
                head[i] = 1;
                grid[cx[i]][cy[i]] = 0;
                EraseGrid(cx[i], cy[i]);
                break;
            }
        }
    }

    void LoadAllBitmaps()
    {
        if (FileExists("Player.bmp"))
            ImgPlayer->Picture->Bitmap->LoadFromFile("Player.bmp");
        if (FileExists("Shot.bmp"))
            ImgShot->Picture->Bitmap->LoadFromFile("Shot.bmp");
        if (FileExists("Seg.bmp"))
            ImgSeg->Picture->Bitmap->LoadFromFile("Seg.bmp");
        if (FileExists("Hleft.bmp"))
            ImgHleft->Picture->Bitmap->LoadFromFile("Hleft.bmp");
        if (FileExists("Hright.bmp"))
            ImgHright->Picture->Bitmap->LoadFromFile("Hright.bmp");
        if (FileExists("Hup.bmp"))
            ImgHup->Picture->Bitmap->LoadFromFile("Hup.bmp");
        if (FileExists("Hdown.bmp"))
            ImgHdown->Picture->Bitmap->LoadFromFile("Hdown.bmp");
        if (FileExists("Spider.bmp"))
            ImgSpider->Picture->Bitmap->LoadFromFile("Spider.bmp");
        if (FileExists("Flea.bmp"))
            ImgFlea->Picture->Bitmap->LoadFromFile("Flea.bmp");
        if (FileExists("Lscorp.bmp"))
            ImgLscorp->Picture->Bitmap->LoadFromFile("Lscorp.bmp");
        if (FileExists("Rscorp.bmp"))
            ImgRscorp->Picture->Bitmap->LoadFromFile("Rscorp.bmp");
        if (FileExists("Mush1.bmp"))
            ImgMush1->Picture->Bitmap->LoadFromFile("Mush1.bmp");
        if (FileExists("Mush2.bmp"))
            ImgMush2->Picture->Bitmap->LoadFromFile("Mush2.bmp");
        if (FileExists("Mush3.bmp"))
            ImgMush3->Picture->Bitmap->LoadFromFile("Mush3.bmp");
        if (FileExists("Mush4.bmp"))
            ImgMush4->Picture->Bitmap->LoadFromFile("Mush4.bmp");
        if (FileExists("Pois1.bmp"))
            ImgPois1->Picture->Bitmap->LoadFromFile("Pois1.bmp");
        if (FileExists("Pois2.bmp"))
            ImgPois2->Picture->Bitmap->LoadFromFile("Pois2.bmp");
        if (FileExists("Pois3.bmp"))
            ImgPois3->Picture->Bitmap->LoadFromFile("Pois3.bmp");
        if (FileExists("Pois4.bmp"))
            ImgPois4->Picture->Bitmap->LoadFromFile("Pois4.bmp");
    }

    void LoadAllSounds()
    {
        if (FileExists("Shotfire.wav"))
            ShotSd = true;
        if (FileExists("Centihit.wav"))
            CenSd = true;
        if (FileExists("Spidhit.wav"))
            SpidSd = true;
        if (FileExists("Fleahit.wav"))
            FleaSd = true;
        if (FileExists("Scorphit.wav"))
            ScoSd = true;
        if (FileExists("Mushhit.wav"))
            MushSd = true;
    }
};
//---------------------------------------------------------------------------
extern PACKAGE TArea *Area;
//---------------------------------------------------------------------------
#endif
